diff --git a/src/gui/MainWidget.cpp b/src/gui/MainWidget.cpp
index 22e46721..c900b8f2 100644
--- a/src/gui/MainWidget.cpp
+++ b/src/gui/MainWidget.cpp
@@ -30,11 +30,15 @@
 #include <QFileDialog>
 #include <QTreeWidget>
 #include <QListWidget>
-#include <QWindow>
-#include <QScreen>
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+    #include <QWindow>
+    #include <QScreen>
+#else
+    #include <QDesktopWidget>
+#endif
 #include <QActionGroup>
 #include <QProxyStyle>
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     #include <QProcess>
 #endif
 #if defined(Q_OS_WIN)
@@ -67,7 +71,7 @@
 #include <ShortcutHandler.hpp>
 #include <VolWidget.hpp>
 #include <ScreenSaver.hpp>
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     #include <QMPlay2MacExtensions.hpp>
 #endif
 
@@ -92,7 +96,7 @@ public:
     }
     ~MainWidgetTmpStyle() = default;
 
-    int pixelMetric(PixelMetric metric, const QStyleOption *option, const QWidget *widget) const override
+    int pixelMetric(PixelMetric metric, const QStyleOption *option, const QWidget *widget) const
     {
         const int pM = QProxyStyle::pixelMetric(metric, option, widget);
         if (metric == QStyle::PM_DockWidgetSeparatorExtent)
@@ -101,7 +105,7 @@ public:
     }
 };
 
-#ifndef Q_OS_MACOS
+#ifndef Q_OS_MAC
 static void copyMenu(QMenu *dest, QMenu *src, const QSet<QMenu *> &dontCopy = {}, const QSet<QMenu *> &dontAdd = {})
 {
     QMenu *newMenu = new QMenu(src->title(), dest);
@@ -117,7 +121,7 @@ static void copyMenu(QMenu *dest, QMenu *src, const QSet<QMenu *> &dontCopy = {}
             else
             {
                 const auto actions = newMenu->actions();
-                if (!actions.isEmpty() && !actions.constLast()->isSeparator())
+                if (!actions.isEmpty() && !actions.last()->isSeparator())
                     newMenu->addAction(act);
             }
         }
@@ -174,7 +178,7 @@ MainWidget::MainWidget(QList<QPair<QString, QString>> &arguments)
 
     QMPlay2GUI.menuBar = new MenuBar;
 
-#if !defined Q_OS_MACOS && !defined Q_OS_ANDROID
+#if !defined Q_OS_MAC && !defined Q_OS_ANDROID
     tray = new QSystemTrayIcon(this);
     tray->setIcon(QMPlay2Core.getIconFromTheme("QMPlay2-panel", QMPlay2Core.getQMPlay2Icon()));
     tray->setVisible(settings.getBool("TrayVisible", true));
@@ -268,14 +272,13 @@ MainWidget::MainWidget(QList<QPair<QString, QString>> &arguments)
 
     for (auto &&dock : getDockWidgets())
     {
-        connect(dock, &DockWidget::shouldStoreSizes, this, [this] {
-            m_storeDockSizesTimer.start();
-        });
+        // Qt4: Use SIGNAL/SLOT syntax
+        connect(dock, SIGNAL(shouldStoreSizes()), this, SLOT(handleShouldStoreSizes()));
     }
 
     m_storeDockSizesTimer.setSingleShot(true);
     m_storeDockSizesTimer.setInterval(0);
-    connect(&m_storeDockSizesTimer, &QTimer::timeout, this, &MainWidget::storeDockSizes);
+    connect(&m_storeDockSizesTimer, SIGNAL(timeout()), this, SLOT(storeDockSizes()));
 
     /* ToolBar and MenuBar */
     createMenuBar();
@@ -342,15 +345,15 @@ MainWidget::MainWidget(QList<QPair<QString, QString>> &arguments)
     connect(infoDock, SIGNAL(chStream(const QString &)), &playC, SLOT(chStream(const QString &)));
     connect(infoDock, SIGNAL(saveCover()), &playC, SLOT(saveCover()));
 
-    connect(videoDock, &VideoDock::resized, &playC, &PlayClass::videoResized);
+    // Qt4: Use SIGNAL/SLOT syntax
+    connect(videoDock, SIGNAL(resized(const QSize &)), &playC, SLOT(videoResized(const QSize &)));
     connect(videoDock, SIGNAL(itemDropped(const QString &, bool)), this, SLOT(itemDropped(const QString &, bool)));
 
     connect(playlistDock, SIGNAL(play(const QString &)), &playC, SLOT(play(const QString &)));
     connect(playlistDock, SIGNAL(repeatEntry(bool)), &playC, SLOT(repeatEntry(bool)));
     connect(playlistDock, SIGNAL(stop()), &playC, SLOT(stop()));
-    connect(playlistDock, &PlaylistDock::addAndPlayRestoreWindow, this, [this] {
-        m_restoreWindowOnVideo = true;
-    });
+    // Qt4: Use helper slot
+    connect(playlistDock, SIGNAL(addAndPlayRestoreWindow()), this, SLOT(handleAddAndPlayRestoreWindow()));
 
     connect(seekS, SIGNAL(valueChanged(int)), this, SLOT(seek(int)));
     connect(seekS, SIGNAL(mousePosition(int)), this, SLOT(mousePositionOnSlider(int)));
@@ -373,14 +376,13 @@ MainWidget::MainWidget(QList<QPair<QString, QString>> &arguments)
     connect(&playC, SIGNAL(playStateChanged(bool)), this, SLOT(playStateChanged(bool)));
     connect(&playC, SIGNAL(setCurrentPlaying()), playlistDock, SLOT(setCurrentPlaying()));
     connect(&playC, SIGNAL(setInfo(const QString &, bool, bool)), infoDock, SLOT(setInfo(const QString &, bool, bool)));
-    connect(&playC, &PlayClass::setStreamsMenu, this, &MainWidget::setStreamsMenu);
+    // Qt4: Use SIGNAL/SLOT syntax
+    connect(&playC, SIGNAL(setStreamsMenu(const QStringList &, const QStringList &, const QStringList &, const QStringList &, const QStringList &)), this, SLOT(setStreamsMenu(const QStringList &, const QStringList &, const QStringList &, const QStringList &, const QStringList &)));
     connect(&playC, SIGNAL(updateCurrentEntry(const QString &, double)), playlistDock, SLOT(updateCurrentEntry(const QString &, double)));
     connect(&playC, SIGNAL(playNext(bool)), playlistDock, SLOT(next(bool)));
     connect(&playC, SIGNAL(clearCurrentPlaying()), playlistDock, SLOT(clearCurrentPlaying()));
-    connect(&playC, &PlayClass::clearInfo, this, [this] {
-        infoDock->clear();
-        setStreamsMenu({}, {}, {}, {}, {});
-    });
+    // Qt4: Use helper slot
+    connect(&playC, SIGNAL(clearInfo()), this, SLOT(handleClearInfo()));
     connect(&playC, SIGNAL(quit()), this, SLOT(deleteLater()));
     connect(&playC, SIGNAL(resetARatio()), this, SLOT(resetARatio()));
     connect(&playC, SIGNAL(updateBitrateAndFPS(int, int, double, double, bool)), infoDock, SLOT(updateBitrateAndFPS(int, int, double, double, bool)));
@@ -388,38 +390,23 @@ MainWidget::MainWidget(QList<QPair<QString, QString>> &arguments)
     connect(&playC, SIGNAL(updateBufferedRange(int, int)), seekS, SLOT(drawRange(int, int)));
     connect(&playC, SIGNAL(updateWindowTitle(const QString &)), this, SLOT(updateWindowTitle(const QString &)));
     connect(&playC, SIGNAL(updateImage(const QImage &)), videoDock, SLOT(updateImage(const QImage &)));
-    connect(&playC, &PlayClass::videoStarted, this, &MainWidget::videoStarted);
-    connect(&playC, &PlayClass::videoNotStarted, this, [this] {
-        m_restoreWindowOnVideo = false;
-    });
+    // Qt4: Use SIGNAL/SLOT syntax
+    connect(&playC, SIGNAL(videoStarted(bool)), this, SLOT(videoStarted(bool)));
+    // Qt4: Use helper slot
+    connect(&playC, SIGNAL(videoNotStarted()), this, SLOT(handleVideoNotStarted()));
     connect(&playC, SIGNAL(uncheckSuspend()), this, SLOT(uncheckSuspend()));
-    connect(&playC, &PlayClass::setVideoCheckState, this, [this](bool rotate90, bool hFlip, bool vFlip, bool spherical) {
-        menuBar->playback->videoFilters->rotate90->setChecked(rotate90);
-        menuBar->playback->videoFilters->hFlip->setChecked(hFlip);
-        menuBar->playback->videoFilters->vFlip->setChecked(vFlip);
-        menuBar->playback->videoFilters->spherical->setChecked(spherical);
-    });
-    connect(&playC, &PlayClass::continuePos, this, [this](double pos, bool canSetVar) {
-        const bool enabled = (pos > 0.0);
-        menuBar->player->continuePlayback->setProperty("Pos", pos);
-        menuBar->player->continuePlayback->setEnabled(enabled);
-        if (canSetVar)
-            playC.setDontResetContinuePlayback(enabled);
-    });
-    connect(&playC, &PlayClass::allowRecording, this, [this](bool allow) {
-        menuBar->player->rec->setEnabled(allow);
-    });
-    connect(&playC, &PlayClass::recording, this, [this](bool status) {
-        QSignalBlocker blocker(menuBar->player->rec);
-        menuBar->player->rec->setChecked(status);
-    });
+    // Qt4: Use helper slots
+    connect(&playC, SIGNAL(setVideoCheckState(bool, bool, bool, bool)), this, SLOT(handleSetVideoCheckState(bool, bool, bool, bool)));
+    connect(&playC, SIGNAL(continuePos(double, bool)), this, SLOT(handleContinuePos(double, bool)));
+    connect(&playC, SIGNAL(allowRecording(bool)), this, SLOT(handleAllowRecording(bool)));
+    connect(&playC, SIGNAL(recording(bool)), this, SLOT(handleRecording(bool)));
 
     /**/
 
     if (settings.getBool("MainWidget/TabPositionNorth"))
         setTabPosition(Qt::AllDockWidgetAreas, QTabWidget::North);
 
-#if !defined Q_OS_MACOS && !defined Q_OS_ANDROID
+#if !defined Q_OS_MAC && !defined Q_OS_ANDROID
     const bool menuHidden = settings.getBool("MainWidget/MenuHidden", false);
     menuBar->setVisible(!menuHidden);
     hideMenuAct = new QAction(tr("&Hide menu bar"), menuBar);
@@ -487,7 +474,7 @@ MainWidget::MainWidget(QList<QPair<QString, QString>> &arguments)
         setAttribute(Qt::WA_NoSystemBackground, false);
     }
 
-#if defined Q_OS_MACOS || defined Q_OS_ANDROID
+#if defined Q_OS_MAC || defined Q_OS_ANDROID
     show();
 #else
     setVisible(!QMPlay2GUI.startInvisible && settings.getBool("MainWidget/isVisible", true) ? true : !isTrayVisible());
@@ -499,25 +486,20 @@ MainWidget::MainWidget(QList<QPair<QString, QString>> &arguments)
         if (tabBar)
         {
             tabBar->setAcceptDrops(true);
+#if QT_VERSION >= QT_VERSION_CHECK(5, 4, 0)
             tabBar->setChangeCurrentOnDrag(true);
+#endif
         }
     }
 
     m_hideDocksTimer.setSingleShot(true);
-    connect(&m_hideDocksTimer, &QTimer::timeout, this, [this] {
-        if (fullScreen || isCompactView)
-        {
-            if (playlistDock->isVisible())
-                hideDocks();
-            else
-                showToolBar(false);
-        }
-    });
+    // Qt4: Use helper slot
+    connect(&m_hideDocksTimer, SIGNAL(timeout()), this, SLOT(handleHideDocksTimeout()));
 
     playlistDock->load(QMPlay2Core.getSettingsDir() + "Playlist.pls");
 
     bool noplay = false;
-    for (const auto &argument : std::as_const(arguments))
+    for (const auto &argument : arguments)
     {
         const QString &param = argument.first;
         const QString &data  = argument.second;
@@ -540,7 +522,14 @@ MainWidget::MainWidget(QList<QPair<QString, QString>> &arguments)
             {
                 double urlPos = 0.0;
                 if (settings.getBool("StoreUrlPos"))
+                {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 2, 0)
                     urlPos = QMPlay2Core.getUrlPosSets().getDouble(url.toUtf8().toBase64(QByteArray::Base64UrlEncoding | QByteArray::OmitTrailingEquals));
+#else
+                    // Qt4: Use basic base64 encoding
+                    urlPos = QMPlay2Core.getUrlPosSets().getDouble(url.toUtf8().toBase64());
+#endif
+                }
                 if (urlPos <= 0.0 || qAbs(urlPos - pos) <= 0.75)
                     seek(pos);
             }
@@ -549,9 +538,9 @@ MainWidget::MainWidget(QList<QPair<QString, QString>> &arguments)
 
     qApp->installEventFilter(this);
 
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     fileOpenTimer.setSingleShot(true);
-    connect(&fileOpenTimer, &QTimer::timeout, this, &MainWidget::fileOpenTimerTimeout);
+    connect(&fileOpenTimer, SIGNAL(timeout()), this, SLOT(fileOpenTimerTimeout()));
     if (QMPlay2GUI.pipe) // Register media keys only for first QMPlay2 instance
         QMPlay2MacExtensions::registerMacOSMediaKeys(std::bind(&MainWidget::processParam, this, std::placeholders::_1, QString()));
 #endif
@@ -564,7 +553,7 @@ MainWidget::MainWidget(QList<QPair<QString, QString>> &arguments)
 }
 MainWidget::~MainWidget()
 {
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     QMPlay2MacExtensions::unregisterMacOSMediaKeys();
 #endif
     QMPlay2Extensions::closeExtensions();
@@ -594,7 +583,7 @@ void MainWidget::focusChanged(QWidget *old, QWidget *now)
         if (w)
         {
             QWidget *tlw = w->window();
-            if (tlw && (tlw == settingsW || tlw == aboutW))
+            if (tlw && (tlw == static_cast<QWidget *>(settingsW) || tlw == static_cast<QWidget *>(aboutW)))
                 return true;
         }
         return (qobject_cast<QAbstractItemView *>(w) || qobject_cast<QTextEdit *>(w) || qobject_cast<QAbstractSlider *>(w) || qobject_cast<QComboBox *>(w) || qobject_cast<QLineEdit *>(w) || qobject_cast<QMenu *>(w));
@@ -616,7 +605,7 @@ void MainWidget::focusChanged(QWidget *old, QWidget *now)
 void MainWidget::processParam(const QString &param, const QString &data)
 {
     auto getItemsToPlay = [&] {
-        auto items = data.split('\n', Qt::SkipEmptyParts);
+        auto items = data.split('\n', QString::SkipEmptyParts);
         for (auto &&item : items)
             item = Functions::maybeExtensionAddress(item);
         return items;
@@ -854,9 +843,14 @@ void MainWidget::visualizationFullScreen()
             toggleFullScreen();
         }
     };
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     // On macOS if full screen is toggled to fast after double click, mouse remains in clicked state...
+#if QT_VERSION >= QT_VERSION_CHECK(5, 4, 0)
     QTimer::singleShot(200, maybeGoFullScreen);
+#else
+    QTimer::singleShot(200, this, SLOT(handleMaybeGoFullScreen()));
+    m_maybeGoFullScreenCallback = maybeGoFullScreen;
+#endif
 #else
     maybeGoFullScreen();
 #endif
@@ -878,7 +872,7 @@ void MainWidget::toggleVisibility()
             toggleFullScreen();
         if (!isTray)
         {
-#ifndef Q_OS_MACOS
+#ifndef Q_OS_MAC
             showMinimized();
 #else
             QMPlay2MacExtensions::setApplicationVisible(false);
@@ -937,12 +931,10 @@ void MainWidget::createMenuBar()
     connect(menuBar->window->toggleCompactView, SIGNAL(triggered()), this, SLOT(toggleCompactView()));
 #ifndef Q_OS_ANDROID
     if (menuBar->window->alwaysOnTop)
-        connect(menuBar->window->alwaysOnTop, &QAction::triggered, this, &MainWidget::toggleAlwaysOnTop);
+        connect(menuBar->window->alwaysOnTop, SIGNAL(triggered(bool)), this, SLOT(toggleAlwaysOnTop(bool)));
     menuBar->window->hideOnClose->setChecked(QMPSettings.getBool("MainWidget/HideOnClose"));
-    connect(menuBar->window->hideOnClose, &QAction::triggered,
-            this, [](bool checked) {
-        QMPlay2Core.getSettings().set("MainWidget/HideOnClose", checked);
-    });
+    // Qt4: Use helper slot
+    connect(menuBar->window->hideOnClose, SIGNAL(triggered(bool)), this, SLOT(handleHideOnCloseTriggered(bool)));
 #endif
     connect(menuBar->window->close, SIGNAL(triggered()), this, SLOT(close()));
 
@@ -958,22 +950,16 @@ void MainWidget::createMenuBar()
     connect(menuBar->playlist->newGroup, SIGNAL(triggered()), playlistDock, SLOT(newGroup()));
     connect(menuBar->playlist->renameGroup, SIGNAL(triggered()), playlistDock, SLOT(renameGroup()));
     connect(menuBar->playlist->lock, SIGNAL(triggered()), playlistDock, SLOT(toggleLock()));
-    connect(menuBar->playlist->alwaysSync, &QAction::triggered, playlistDock, &PlaylistDock::alwaysSyncTriggered);
-    connect(menuBar->playlist->delEntries, &QAction::triggered, playlistDock, [this] {
-        playlistDock->delEntries(false);
-    });
-    connect(menuBar->playlist->delEntriesFromDisk, &QAction::triggered, playlistDock, [this] {
-        playlistDock->delEntries(true);
-    });
+    connect(menuBar->playlist->alwaysSync, SIGNAL(triggered(bool)), playlistDock, SLOT(alwaysSyncTriggered(bool)));
+    // Qt4: Use helper slots
+    connect(menuBar->playlist->delEntries, SIGNAL(triggered()), this, SLOT(handleDelEntries()));
+    connect(menuBar->playlist->delEntriesFromDisk, SIGNAL(triggered()), this, SLOT(handleDelEntriesFromDisk()));
     connect(menuBar->playlist->delNonGroupEntries, SIGNAL(triggered()), playlistDock, SLOT(delNonGroupEntries()));
     connect(menuBar->playlist->clear, SIGNAL(triggered()), playlistDock, SLOT(clear()));
     connect(menuBar->playlist->copy, SIGNAL(triggered()), playlistDock, SLOT(copy()));
-    connect(menuBar->playlist->paste, &QAction::triggered, playlistDock, [this] {
-        playlistDock->paste(false);
-    });
-    connect(menuBar->playlist->pasteAndPlay, &QAction::triggered, playlistDock, [this] {
-        playlistDock->paste(true);
-    });
+    // Qt4: Use helper slots
+    connect(menuBar->playlist->paste, SIGNAL(triggered()), this, SLOT(handlePaste()));
+    connect(menuBar->playlist->pasteAndPlay, SIGNAL(triggered()), this, SLOT(handlePasteAndPlay()));
     connect(menuBar->playlist->find, SIGNAL(triggered()), playlistDock->findEdit(), SLOT(setFocus()));
     connect(menuBar->playlist->sort->timeSort1, SIGNAL(triggered()), playlistDock, SLOT(timeSort1()));
     connect(menuBar->playlist->sort->timeSort2, SIGNAL(triggered()), playlistDock, SLOT(timeSort2()));
@@ -991,7 +977,7 @@ void MainWidget::createMenuBar()
     connect(menuBar->player->stop, SIGNAL(triggered()), &playC, SLOT(stop()));
     connect(menuBar->player->next, SIGNAL(triggered()), playlistDock, SLOT(next()));
     connect(menuBar->player->prev, SIGNAL(triggered()), playlistDock, SLOT(prev()));
-    connect(menuBar->player->rec, &QAction::triggered, &playC, &PlayClass::setRecording);
+    connect(menuBar->player->rec, SIGNAL(triggered(bool)), &playC, SLOT(setRecording(bool)));
     connect(menuBar->player->prevFrame, SIGNAL(triggered()), &playC, SLOT(prevFrame()));
     connect(menuBar->player->nextFrame, SIGNAL(triggered()), &playC, SLOT(nextFrame()));
     for (QAction *act : menuBar->player->repeat->actions())
@@ -1004,15 +990,15 @@ void MainWidget::createMenuBar()
     connect(menuBar->player->speedUp, SIGNAL(triggered()), &playC, SLOT(speedUp()));
     connect(menuBar->player->slowDown, SIGNAL(triggered()), &playC, SLOT(slowDown()));
     connect(menuBar->player->setSpeed, SIGNAL(triggered()), &playC, SLOT(setSpeed()));
-    connect(menuBar->player->zoom->integerScaling, &QAction::toggled, menuBar->player->zoom->setZoom, &QAction::setDisabled);
-    connect(menuBar->player->zoom->integerScaling, &QAction::toggled, menuBar->player->zoom->preciseZoom, &QAction::setDisabled);
+    connect(menuBar->player->zoom->integerScaling, SIGNAL(toggled(bool)), menuBar->player->zoom->setZoom, SLOT(setDisabled(bool)));
+    connect(menuBar->player->zoom->integerScaling, SIGNAL(toggled(bool)), menuBar->player->zoom->preciseZoom, SLOT(setDisabled(bool)));
     menuBar->player->zoom->integerScaling->setChecked(QMPSettings.getBool("IntegerScaling"));
     menuBar->player->zoom->preciseZoom->setChecked(QMPSettings.getBool("PreciseZoom"));
-    connect(menuBar->player->zoom->integerScaling, &QAction::triggered, &playC, &PlayClass::setIntegerScaling);
-    connect(menuBar->player->zoom->preciseZoom, &QAction::triggered, &playC, &PlayClass::setPreciseZoom);
+    connect(menuBar->player->zoom->integerScaling, SIGNAL(triggered(bool)), &playC, SLOT(setIntegerScaling(bool)));
+    connect(menuBar->player->zoom->preciseZoom, SIGNAL(triggered(bool)), &playC, SLOT(setPreciseZoom(bool)));
     connect(menuBar->player->zoom->zoomIn, SIGNAL(triggered()), &playC, SLOT(zoomIn()));
     connect(menuBar->player->zoom->zoomOut, SIGNAL(triggered()), &playC, SLOT(zoomOut()));
-    connect(menuBar->player->zoom->setZoom, &QAction::triggered, &playC, &PlayClass::setZoom);
+    connect(menuBar->player->zoom->setZoom, SIGNAL(triggered()), &playC, SLOT(setZoom()));
     connect(menuBar->player->switchARatio, SIGNAL(triggered()), this, SLOT(switchARatio()));
     {
         const QString initialAspectRatio = QMPSettings.getBool("StoreARatioAndZoom") ? QMPSettings.getString("AspectRatio") : QString();
@@ -1020,7 +1006,7 @@ void MainWidget::createMenuBar()
         bool aRatioTriggered = false;
         for (QAction *act : menuBar->player->aRatio->actions())
         {
-            connect(act, &QAction::triggered, &playC, &PlayClass::aRatio);
+            connect(act, SIGNAL(triggered()), &playC, SLOT(aRatio()));
             if (aRatioTriggered)
                 continue;
             const auto objectName = act->objectName();
@@ -1042,13 +1028,8 @@ void MainWidget::createMenuBar()
     connect(menuBar->player->reset, SIGNAL(triggered()), this, SLOT(resetARatio()));
     connect(menuBar->player->reset, SIGNAL(triggered()), &playC, SLOT(zoomReset()));
     connect(menuBar->player->reset, SIGNAL(triggered()), &playC, SLOT(otherReset()));
-    connect(menuBar->player->continuePlayback, &QAction::triggered, this, [this] {
-        const double pos = menuBar->player->continuePlayback->property("Pos").toDouble();
-        if (pos > 0.0)
-            playC.seek(pos);
-        else
-            emit playC.continuePos(0.0, true);
-    });
+    // Qt4: Use helper slot
+    connect(menuBar->player->continuePlayback, SIGNAL(triggered()), this, SLOT(handleContinuePlayback()));
     connect(menuBar->player->volUp, SIGNAL(triggered()), this, SLOT(volUpDown()));
     connect(menuBar->player->volDown, SIGNAL(triggered()), this, SLOT(volUpDown()));
     connect(menuBar->player->toggleMute, SIGNAL(triggered()), &playC, SLOT(toggleMute()));
@@ -1062,7 +1043,7 @@ void MainWidget::createMenuBar()
     if (menuBar->playback->keepAudioPitch)
     {
         menuBar->playback->keepAudioPitch->setChecked(QMPSettings.getBool("KeepAudioPitch"));
-        connect(menuBar->playback->keepAudioPitch, &QAction::triggered, &playC, &PlayClass::setKeepAudioPitch);
+        connect(menuBar->playback->keepAudioPitch, SIGNAL(triggered(bool)), &playC, SLOT(setKeepAudioPitch(bool)));
     }
     connect(menuBar->playback->toggleVideo, SIGNAL(triggered(bool)), &playC, SLOT(toggleAVS(bool)));
     connect(menuBar->playback->toggleSubtitles, SIGNAL(triggered(bool)), &playC, SLOT(toggleAVS(bool)));
@@ -1108,7 +1089,7 @@ void MainWidget::createMenuBar()
 
     setMenuBar(menuBar);
 
-#ifndef Q_OS_MACOS
+#ifndef Q_OS_MAC
     if (tray)
     {
         auto secondMenu = new QMenu(this);
@@ -1138,18 +1119,8 @@ void MainWidget::createMenuBar()
         }
         tray->setContextMenu(secondMenu);
 
-        connect(secondMenu, &QMenu::aboutToShow,
-                this, [=] {
-            for (auto ext : QMPlay2Extensions::QMPlay2ExtensionsList())
-            {
-                if (auto menu = ext->getTrayMenu())
-                {
-                    ext->ensureTrayMenu();
-                    if (!secondMenu->actions().contains(menu->menuAction()))
-                        secondMenu->addMenu(menu);
-                }
-            }
-        });
+        // Qt4: Use helper slot
+        connect(secondMenu, SIGNAL(aboutToShow()), this, SLOT(handleSecondMenuAboutToShow()));
     }
 #else //On OS X add only the most important menu actions to dock menu
     auto secondMenu = new QMenu(this);
@@ -1162,22 +1133,23 @@ void MainWidget::createMenuBar()
     secondMenu->addSeparator();
     // Copy action, because PreferencesRole doesn't show in dock menu.
     QAction *settings = new QAction(menuBar->options->settings->icon(), menuBar->options->settings->text(), menuBar->options->settings->parent());
-    connect(settings, &QAction::triggered, menuBar->options->settings, &QAction::trigger);
+    connect(settings, SIGNAL(triggered()), menuBar->options->settings, SLOT(trigger()));
     secondMenu->addAction(settings);
 
     QAction *newInstanceAct = new QAction(tr("New window"), secondMenu);
-    connect(newInstanceAct, &QAction::triggered, [] {
-        QProcess::startDetached(QCoreApplication::applicationFilePath(), {"-noplay"}, QCoreApplication::applicationDirPath());
-    });
+    // Qt4: Use helper slot
+    connect(newInstanceAct, SIGNAL(triggered()), this, SLOT(handleNewInstance()));
     secondMenu->addSeparator();
     secondMenu->addAction(newInstanceAct);
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 2, 0)
     secondMenu->setAsDockMenu();
 #endif
+#endif
 }
 void MainWidget::trayIconClicked(QSystemTrayIcon::ActivationReason reason)
 {
-#if !defined Q_OS_MACOS && !defined Q_OS_ANDROID
+#if !defined Q_OS_MAC && !defined Q_OS_ANDROID
     switch (reason)
     {
         case QSystemTrayIcon::Trigger:
@@ -1205,7 +1177,7 @@ void MainWidget::toggleCompactView()
 
         hideDockWidgetsAndDisableFeatures();
 
-#if !defined Q_OS_MACOS && !defined Q_OS_ANDROID
+#if !defined Q_OS_MAC && !defined Q_OS_ANDROID
         menuBar->hide();
 #endif
         mainTB->hide();
@@ -1228,7 +1200,7 @@ void MainWidget::toggleCompactView()
 
         restoreDockWidgetFeatures();
 
-#if !defined Q_OS_MACOS && !defined Q_OS_ANDROID
+#if !defined Q_OS_MAC && !defined Q_OS_ANDROID
         menuBar->setVisible(!hideMenuAct->isChecked());
 #endif
 
@@ -1251,7 +1223,7 @@ void MainWidget::toggleAlwaysOnTop(bool checked)
 void MainWidget::toggleFullScreen()
 {
     static bool visible, tb_movable;
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     if (isFullScreen())
     {
         showNormal();
@@ -1268,7 +1240,7 @@ void MainWidget::toggleFullScreen()
 #ifndef Q_OS_ANDROID
         m_maximizedBeforeFullScreen = isMaximized();
 
-#ifndef Q_OS_MACOS
+#ifndef Q_OS_MAC
 #ifndef Q_OS_WIN
         if (isFullScreen())
 #endif
@@ -1282,7 +1254,7 @@ void MainWidget::toggleFullScreen()
         dockWidgetState = saveState();
 #endif // Q_OS_ANDROID
 
-#if !defined Q_OS_MACOS
+#if !defined Q_OS_MAC
         menuBar->hide();
 #endif
         statusBar->hide();
@@ -1297,22 +1269,31 @@ void MainWidget::toggleFullScreen()
         videoDock->fullScreen(true);
         videoDock->show();
 
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
         menuBar->window->toggleVisibility->setEnabled(false);
 #endif
         menuBar->window->toggleCompactView->setEnabled(false);
         menuBar->window->toggleFullScreen->setShortcuts(QList<QKeySequence>() << menuBar->window->toggleFullScreen->shortcut() << QKeySequence("ESC"));
         fullScreen = true;
 
-#ifndef Q_OS_MACOS
+#ifndef Q_OS_MAC
         showFullScreen();
 #else
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         const auto geo = window()->windowHandle()->screen()->geometry();
         setMinimumSize(geo.size());
         setWindowFlags(Qt::Window | Qt::FramelessWindowHint);
         setGeometry(geo);
         QMPlay2MacExtensions::showSystemUi(windowHandle(), false);
         show();
+#else
+        // Qt4: Use QDesktopWidget for screen geometry
+        const QRect geo = QApplication::desktop()->screenGeometry(this);
+        setMinimumSize(geo.size());
+        setWindowFlags(Qt::Window | Qt::FramelessWindowHint);
+        setGeometry(geo);
+        show();
+#endif
 #endif
 
         if (playC.isPlaying())
@@ -1320,7 +1301,7 @@ void MainWidget::toggleFullScreen()
     }
     else
     {
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
         menuBar->window->toggleVisibility->setEnabled(true);
 #endif
         menuBar->window->toggleCompactView->setEnabled(true);
@@ -1330,20 +1311,22 @@ void MainWidget::toggleFullScreen()
         fullScreen = false;
 
 #ifndef Q_OS_ANDROID
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
         setMinimumSize(0, 0);
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         QMPlay2MacExtensions::showSystemUi(windowHandle(), true);
+#endif
         setWindowFlags(Qt::Window);
 #else
         showNormal();
-#endif // Q_OS_MACOS
+#endif // Q_OS_MAC
         if (m_maximizedBeforeFullScreen)
         {
             showMaximized();
         }
         else
         {
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
             showNormal();
 #endif
             setGeometry(savedGeo);
@@ -1367,7 +1350,7 @@ void MainWidget::toggleFullScreen()
 
 #if defined(Q_OS_ANDROID)
         menuBar->setVisible(true);
-#elif !defined Q_OS_MACOS
+#elif !defined Q_OS_MAC
         menuBar->setVisible(!hideMenuAct->isChecked());
 #endif
         statusBar->show();
@@ -1463,26 +1446,21 @@ void MainWidget::showSettings(const QString &moduleName)
 
         settingsW = new SettingsWidget(page, moduleName, QMPlay2GUI.videoAdjustment);
         if (windowFlags() & Qt::WindowStaysOnTopHint)
+        {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 9, 0)
             settingsW->setWindowFlag(Qt::WindowStaysOnTopHint);
+#else
+            settingsW->setWindowFlags(settingsW->windowFlags() | Qt::WindowStaysOnTopHint);
+#endif
+        }
         settingsW->show();
-        connect(settingsW, &SettingsWidget::settingsChanged, this, [this](int page, bool forceRestart, bool initFilters) {
-            Q_UNUSED(forceRestart);
-            Q_UNUSED(initFilters);
-            if (page == 2)
-                setContinuePlaybackVisibility();
-        });
+        // Qt4: Use helper slots
+        connect(settingsW, SIGNAL(settingsChanged(int, bool, bool)), this, SLOT(handleSettingsChanged(int, bool, bool)));
         connect(settingsW, SIGNAL(settingsChanged(int, bool, bool)), &playC, SLOT(settingsChanged(int, bool, bool)));
         connect(settingsW, SIGNAL(setWheelStep(int)), seekS, SLOT(setWheelStep(int)));
         connect(settingsW, SIGNAL(setVolMax(int)), volW, SLOT(setMaximumVolume(int)));
-        connect(settingsW, &SettingsWidget::keepDocksSizeChanged, this, [this](bool keepDocksSize) {
-            m_keepDocksSize = keepDocksSize;
-            m_storeDockSizesTimer.start();
-        });
-        connect(settingsW, &SettingsWidget::fullscreenPanelsRightSideChanged, this, [this](bool checked) {
-            m_fullscreenPanelsRightSide = checked;
-            fullScreenDockWidgetState.clear();
-            m_compactViewDockWidgetState.clear();
-        });
+        connect(settingsW, SIGNAL(keepDocksSizeChanged(bool)), this, SLOT(handleKeepDocksSizeChanged(bool)));
+        connect(settingsW, SIGNAL(fullscreenPanelsRightSideChanged(bool)), this, SLOT(handleFullscreenPanelsRightSideChanged(bool)));
         connect(settingsW, SIGNAL(destroyed()), this, SLOT(showSettings()));
     }
     else
@@ -1603,7 +1581,13 @@ void MainWidget::about()
     {
         aboutW = new AboutWidget;
         if (windowFlags() & Qt::WindowStaysOnTopHint)
+        {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 9, 0)
             aboutW->setWindowFlag(Qt::WindowStaysOnTopHint);
+#else
+            aboutW->setWindowFlags(aboutW->windowFlags() | Qt::WindowStaysOnTopHint);
+#endif
+        }
         aboutW->show();
         connect(aboutW, SIGNAL(destroyed()), this, SLOT(about()));
     }
@@ -1614,7 +1598,7 @@ void MainWidget::about()
     }
 }
 
-#if !defined Q_OS_MACOS && !defined Q_OS_ANDROID
+#if !defined Q_OS_MAC && !defined Q_OS_ANDROID
 void MainWidget::hideMenu(bool h)
 {
     if (fullScreen || isCompactView)
@@ -1652,6 +1636,7 @@ void MainWidget::doRestoreState(const QByteArray &data, bool doToggleCompactView
     if (isMaximized())
     {
         setUpdatesEnabled(false);
+#if QT_VERSION >= QT_VERSION_CHECK(5, 4, 0)
         QTimer::singleShot(0, this, [=] {
             QTimer::singleShot(0, this, [=] {
                 QTimer::singleShot(0, this, [=] {
@@ -1663,6 +1648,12 @@ void MainWidget::doRestoreState(const QByteArray &data, bool doToggleCompactView
                 });
             });
         });
+#else
+        // Qt4: Store state and trigger helper
+        m_restoreStateData = data;
+        m_restoreStateToggleCompactView = doToggleCompactView;
+        QTimer::singleShot(0, this, SLOT(handleRestoreState1()));
+#endif
     }
     else
     {
@@ -1687,7 +1678,7 @@ void MainWidget::setStreamsMenu(const QStringList &videoStreams, const QStringLi
             auto lines = videoStream.split(QLatin1Char('\n'));
             Q_ASSERT(lines.size() >= 2);
 
-            auto action = menu->addAction(lines.constFirst());
+            auto action = menu->addAction(lines.first());
             const bool hasData = !lines.at(1).isEmpty();
 
             if (menu->group)
